#include <stdio.h>
#include <opencv2/opencv.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>

using namespace cv;

int main(int argc, const char* argv[])
{
    Mat src;

    src = imread("laser_60cm.jpg");

    Mat dst;
    cvtColor(src, dst, CV_BGR2GRAY);
    double maxVal;
    Point maxPos;
    minMaxLoc(dst, NULL, &maxVal, NULL, &maxPos);
    threshold(dst, dst, maxVal-1, 255, THRESH_BINARY);

    circle(src, maxPos, 3, 255, 2);
    printf("X=%d\n", maxPos.x);

    namedWindow("HelloCVsrc");
    imshow("HelloCVsrc", src);

    namedWindow("HelloCV");
    imshow("HelloCV", dst);

    waitKey();

    return 0;
} 

