#include <stdio.h>
#include <opencv2/opencv.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>

using namespace cv;

int main(int argc, const char* argv[])
{
    VideoCapture cap(1);

    if (!cap.isOpened()) {
        printf("Webcam open error\n");
        return -1;
    }
    cap.set(CV_CAP_PROP_FRAME_WIDTH, 640);
    cap.set(CV_CAP_PROP_FRAME_HEIGHT, 480);

    Mat src;

    namedWindow("HelloCV");
    
    while (1) {
        cap >> src;

        double maxVal;
        Point maxPos;
        Mat dst;
        cvtColor(src, dst, CV_BGR2GRAY);
        minMaxLoc(dst, NULL, &maxVal, NULL, &maxPos);
        circle(src, maxPos, 3, 255, 2);

        const double d = 5.0;
        const double alfa = 30;
        const double tan_alfa = tan(M_PI*alfa/180.0);
        const double beta_max = 26.5;
        const double tan_beta_max = tan(M_PI*beta_max/180.0);
        double tan_beta = (320.0 - maxPos.x) / 320.0 * tan_beta_max;
        double h = d / (tan_alfa - tan_beta);

        printf("X=%5d h=%g\n", maxPos.x, h);

        imshow("HelloCV", src);

        if (waitKey(10)>0) return 0;
    }

    return 0;
} 

